PROGRAM kartov1;                           (* kartesisches Oval 31.8.1996 *)
(* Kurve besteht aus zwei Aesten Hier werden alle zwei gezeichnet         *)
(* Voraussetzung Alpha > Beta und C/Alpha > 2*E beruecksichtigen          *)

USES CRT,UNIGRA12;

 (* ----------------------- Unterprogramme ------------------------------- *)
  Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.1,1.0,5.0);  (* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

  Procedure Beschriftung;
  CONST
  N = 10;
  VAR
  XUntergr,XObergr,YUntergr,YObergr         : STRING[Bz1];
  einhS: STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  T: Ttyp;
  PText : Pt2DInt;
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:1,einhS);
   
  
(* ----------------------------- TEXTE --------------------------------- *)
  T[1] := 'kartesisches Oval:  Alpha*rho1 + Beta*rho2 = C ';
  T[2] := 'beide Aeste der Kurve gezeichnet';
  T[3] := 'Alpha = 3 Beta = 2  C = 7   E = 1';
  T[4] := 'A = 2*Alpha*C/(Alpha^2-Beta^2) B = -4*E*Beta^2/(Alpha^2-Beta^2)';
  T[5] := 'D^2 = (C*C - 4*E*E*Beta*Beta)/(Alpha^2-Beta^2)    rho1 = R';
  T[6] := 'R*R = R(A + B*COS(T)) + D^2 = 0';
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[7] := Ttemp1 + Ttemp2;
  T[8] := '1 Einheit entspricht'+einhS+'  cm';
  Text_ausgeben(T,8);                                 (* 8 Texte ausgeben *)
  END;



 Procedure TtoXY(T,R: EXTENDED; VAR X,Y: EXTENDED);
    BEGIN
    (* ================================================== *)
      X := R*COS(T);                            (* Umrechnung in           *)
      Y := R*SIN(T);                            (* Kartesische Koordinaten *)
    (* ================================================== *)
    END;

 Procedure Zeichne_Oval(Alpha,Beta,C,E,TMin,TMax : EXTENDED;TSteps : INTEGER);
   VAR
     I: INTEGER;
     X,Y,T,DeltaT: EXTENDED;
     A,B,D2,Nenner,PHalbe,Diskr,R1,R2: EXTENDED;
     P: Pt2D;
   BEGIN
     DeltaT := (TMax-TMin)/TSteps;
     Nenner := Alpha*Alpha - Beta*Beta;
     A := 2*Alpha*C/Nenner;
     B := -4*E*Beta*Beta/Nenner;
     D2 := (C*C - 4*E*E*Beta*Beta)/Nenner;
    Col := 15;
     IF Plot THEN  WRITE(AUX,'PW0.1');                  (* duenner Strich *)
     T := TMin;
     PHalbe := (A + B*COS(T))/2.0;
     Diskr := PHalbe*PHalbe - D2;
     IF Diskr > 0.0 THEN  R1 := PHalbe + SQRT(Diskr);
     TtoXY(T,R1,X,Y);
     P.X := X; P.Y := Y;
     MoveToPt2D(P);
     FOR I := 0 TO TSteps DO
       BEGIN
         T := TMin + I*DeltaT;
         PHalbe := (A + B*COS(T))/2;
         Diskr := PHalbe*PHalbe - D2;
         IF Diskr > 0.0 THEN R1 := PHalbe + SQRT(Diskr);
         TtoXY(T,R1,X,Y);
         P.X := X; P.Y := Y;
         DrawtoPt2D(P,Col);
       END;                             
    Col := 15;
    IF Plot THEN  WRITE(AUX,'PW0.1');                    (* duenner Strich *)
    T := TMin;
    PHalbe := (A + B*COS(T))/2.0;
    Diskr := PHalbe*PHalbe - D2;
    IF Diskr > 0.0 THEN  R2 := PHalbe - SQRT(Diskr);
    TtoXY(T,R2,X,Y);
    P.X := X; P.Y := Y;
    MoveToPt2D(P);
    FOR I := 0 TO TSteps DO
      BEGIN
        T := TMin + I*DeltaT;
        PHalbe := (A + B*COS(T))/2.0;
        Diskr := PHalbe*PHalbe - D2;
        IF Diskr > 0.0 THEN R2 := PHalbe - SQRT(Diskr);
        TtoXY(T,R2,X,Y);  
        P.X := X; P.Y := Y;
        DrawtoPt2D(P,Col);
      END;                                
    END;
 
  Procedure Kartesisches_Oval;
   VAR
   TMin, TMax: EXTENDED;
   TSteps: INTEGER;
   Alpha,Beta,C,E : EXTENDED;
   BEGIN
     TMin := 0.0; TMax := 2*Pi; TSteps := 200;
     Alpha := 3.0; Beta := 2.0; C := 7.0; E := 1.0;
     Zeichne_Oval(Alpha,Beta,C,E,TMin,TMax,TSteps);
   END;

 (* ====================================================================  *)
 (*                         HAUPTPROGRAMM                                 *)

BEGIN
  Schnittstelle_waehlen(1);                (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;  
  einh := 1.0;    (* 1 Einheit auf der X-Achse und Y-Achse entspricht 1 cm *)
                          (* erster Punkt links unten kann gewaehlt werden *)
  WI2D[1].X := -19.0;  WI2D[1].Y := -9.0;       (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Kartesisches_Oval;
  Beschriftung;
  WClosegraph;
END.
 
      